/*  smpcbrtx.cpp  by K.Tsuru  */

const char* const title = "<<<<< A sample program for cubic root Cbrt(x). >>>>>";

#include "sn.h"

int main(){
	int fig;
	RealSize C;
	SDouble x, y;
	x.SetFormat(10, 0, 5,x.CRLF | x.INT_PUT | x.SHOW_FIG);

	cerr << title << endl;
	cerr << "Effective figures/" << DFIGURES << " = ? ";
	fig = GetInt();
	if(fig <= 0) return EXIT_FAILURE;
	C.SetEffFig(fig, C.TEMP_EXTEND);
	cerr << endl << "Your effective figures in a decimal system = " << DFIGURES*x.EffFig() << "." << endl;
	cerr << "If you choose ON, it sets Verify() OFF. ";
	cerr << "PreferSpeed() ON(1)/OFF(0) ?= ";
	C.PreferSpeed(GetInt());

	Timer timer;
	double cpu_time;
	bool output;

	while(1){
		cerr << "To get Cbrt(x), input x =(abort when x = 0) ? ";
		cin >> x;
		if(x == 0.0) break;
		x.FFTUsedTimes(0);
		timer.Start();
		y = Cbrt(x);
		cpu_time = timer.Stop();
		output = true;
		if(y.DFigures() > 5000L){
	 		cerr << "Output the result Yes(1)/No(0) ? ";
			output = (GetInt() == 1) ? true : false;
		}
		if(output) cout << y << endl;
		cout << "cpu time = " << cpu_time << "sec, " << y.DFigures() << " figures" << endl;
		cout << "fftMult() used " << y.FFTUsedTimes() <<" times." << endl;
		cout << "Iteration times in Newton method = " << y.ItrCounts() << "." << endl;
		Wait();

		cerr << "Calculating cubic.";
		x.FFTUsedTimes(0);
		timer.Start();
		y = Dpow(y, 3) -x;
		cpu_time = timer.Stop();
		cout << "(x^(1/3))^3 - x =" << y << endl;
		cout << "cpu time = " << cpu_time << "sec." << endl;

		cout << "Size of x = " << x.Size() << " and size of y = " << y.Size();
		cout << " fftMult() used " << y.FFTUsedTimes() <<" times." << endl;
		Wait();
	}
}
