/*  smpfract.cpp  by K.Tsuru  */ 
const char* title = "<<<< A sample program of SFraction class >>>>>";
#include "sn.h"

void ExpSeriesSpeedTest(int n, long sgn){
	RealSize C;
	uint fig = (uint)Stirling((long)abs(n))/DFIGURES + 10u;
	Timer timer;
	SLong f;
	SFraction r, sum;
	int i;
	double t;
	C.SetEffFig(fig);

	SDouble d, e, den, num, diff;

	e = E();
	cout << e << endl;
	f = 1;
	if(sgn > 0){
		sum = 2;
		cerr << "Now calculating 1/0! + 1/1! + 1/2! + .... 1/" << n << "! in fraction." << endl;
	}else{
		sum = 0.0;
		e = 1.0/e;
		cerr << "Now calculating 1/0! - 1/1! + 1/2! - .... 1/" << n << "! in fraction." << endl;
	}
	timer.Start();
	for(i = 2; i <= n; i++){
		f *= i;
		r.Set(1.0, f);
		if( (sgn > 0) || !(i % 2)) sum = sum + r;
		else sum = sum - r;
	}
	sum.Reduce();
	t = timer.Stop();
	cout << "In fraction." << endl;
	cout << sum << endl;
	Wait();

	cout << "In decimal." << endl;
	d = sum;	// SFraction --> SDouble conversion
	cout << d << endl;
	Wait();

	if(sgn > 0) cout << "E() =";
	else cout << "1/E() =";
	cout << e << endl;
	cout << AgreeUpTo(d, e) << " figures agrees." << endl;
	diff= d -e;
	if(sgn > 0) cout << "Diffrence E()." << endl;
	else cout << "Diffrence 1/E()." << endl;
	cout << diff << endl;
	cout << "CPU time = " << t << endl;
	Wait();
	C.SetEffFig(0);
}
void ExpSeriesByFraction(){
	int upto;
	cerr << "To caluculate" << endl << " e = 1/0! + 1/1! + 1/2! + .... 1/n! or" << endl;
	cerr << "1/e = 1/0! - 1/1! + 1/2! - .... 1/n! in fraction." << endl;
	while(1){
		cerr << " n = ?(when n <= 0, quit) ";
		upto = GetInt();
		if(upto <= 0) break;
		ExpSeriesSpeedTest(upto, 1);
		ExpSeriesSpeedTest(upto, -1);
	}
}
void test3(){
	SFraction f;
	char den[] = "98802 88843 41918 88553 74605 18912";
	char num[] = "72 05759 40368 79360";
	SLong D(den), N(num), G;

	G = gcdL(D, N);
	cout << "GCD of " << D << " and " << N << " is" << endl;
	cout << G << endl;
	cout << "Reduceed value of (" << D << "/" << N << ") is" << endl;
	f.Set(D, N);
	cout << f << endl;

	Wait();
}
void test2(){
// by Moriguti
	SFraction f, g, r;
	f = "1009/99799811";	g = "997/99819757";
	r = f+g;	cout << f << '+' << g << '=' << r << endl;
	r = f-g;	cout << f << '-' << g << '=' << r << endl;
	r = f*g;	cout << f << '*' << g << '=' << r << endl;
	r = f/g;	cout << f << '/' << g << '=' << r << endl;
	Wait();
}
void test1(){
	SFraction f(1, 300), g(1, 400), r;
	r = f+g;	cout << f << '+' << g << '=' << r << endl;
	r = f-g;	cout << f << '-' << g << '=' << r << endl;
	r = f*g;	cout << f << '*' << g << '=' << r << endl;
	r = f/g;	cout << f << '/' << g << '=' << r << endl;
	Wait();
	f+=g;
	cout << f << endl;
	r = 300.0 * g;
	cout << r << endl;
	r = g * 300.0;
	cout << r << endl;
}
int main(){
	ErrorPuts(title);
	test1();
	test2();
	test3();

	SFraction::SetFormat(SFraction::MID_CR);
	ExpSeriesByFraction();
	Ending();
}
