/*  SMPTRG1.CPP  by K.Tsuru  */ 
static const char* title = "<<<<< A sample program for trigonometric functions >>>>>\n";

#include "sn.h"

void ShowCalcInfo(const SDouble& c, double cpu_time){
	printf("Up to %ldth terms, cpu time = %.3f\n",c.UpToTerm(), cpu_time);
}
void FuncXSpeedTest(SDouble (*pfunc)(const SDouble&),
const char* fname, const char* range){
	RealSize C;
	Timer timer;
	double cpu_time, X;
	uint fig;
	fprintf(stderr, "A test for %s. Effective figures / %d = ? ", fname, DFIGURES);
	fig = GetInt();
	C.SetEffFig(fig);
	SDouble x, r;

	while(1){
		if(range == NULL){
			fprintf(stderr, "Input x = (Abort when x = 0)? ");
			X = GetDouble();
		} else {
			X = 10.0;
			while( fabs(X) > 1.0){
				fprintf(stderr, "Input x(%s) = (Abort when x = 0)? ", range);
				X = GetDouble();
			}
		}
		if(X == 0.0) break;
		x = X;
		printf("Your x = ");	x.Puts();
		fprintf(stderr, "Calculating %s\n", fname);
		timer.Start();
		r = (*pfunc)(x);
		cpu_time = timer.Stop();
		r.Puts();
		ShowCalcInfo(r, cpu_time);
		Wait();
	}
	C.SetEffFig(0);
}
int main(){
	ErrorPuts(title);
	FuncXSpeedTest(Sin, "Sin(x)", NULL);
	FuncXSpeedTest(Cos, "Cos(x)", NULL);
	FuncXSpeedTest(Tan, "Tan(x)", NULL);
	FuncXSpeedTest(Asin, "Asin(x)", "|x| <= 1.0");
	FuncXSpeedTest(Acos, "Acos(x)", "|x| <= 1.0");
	FuncXSpeedTest(Atan, "Atan(x)", NULL);

	Ending();
	return EXIT_SUCCESS;
}
