/*  spltlgfl.cpp  by K.Tsuru  */
/*
Split the decimal part of large number file in the form
3.+
1415...

exsample               large file name              lines        out file
SplitLargeFile("ChudnovskysPi[1billion].dat", 1000000,"ChudPi%02d.dat");
*/
#include <stdlib.h>
#include <fstream>
#include <string.h>
using namespace std;
int SplitLargeFile(const char* largeFileName, const long fileLineUnit, const char* outFNameFormat)
{
	const int buffLength = 500;
	char splitFname[257], buff[buffLength];
	bool point = false; // decimal point
	ifstream read(largeFileName, ios::in);
	if(!read) return (-1);
	while(!point && !read.eof()) { // search point '.'
		read.getline(buff, buffLength, '\n');
		if(strchr(buff, '.')) point = true;
	}
// puts(buff);
	if(!point) return -2;  // not decimal file

	ofstream fout;
	int fNo = 1, line = 1;
	while(!read.eof()) {
		sprintf(splitFname, outFNameFormat, fNo);
		fout.open(splitFname, ios::out);
		if(fNo == 1) fout << buff << endl;  // part of "2.+"
		do { // write one block(a split file)
			read.getline(buff, buffLength, '\n');
			fout << buff << endl; line++;
			if(line > fileLineUnit){
				line = 1;	fNo++;
				fout.close(); break;
			}
		} while(strlen(buff));
	}
	return fNo;
}

