/*  scfasinh.cpp  by K.Tsuru  */
// function ID = 9119  since ver 2.18
/*****************************************
SComplex class
It returns arsinh(z).
Casinh(z) = Clog{z + Csqrt(z^2 + 1)}.
= (1/i)arcsin(iz)
(Gradshteyn and Ryzhik 2000, p. xxx)
ver 2.21
*****************************************/
#ifndef SN_H
#include "sn.h"
#endif

#if 0
SComplex Casinh(const SComplex& z) {
	SComplex y = Csqrt(z * z + 1.0);

	return Clog(z + y);
}
#else /********************************/

SComplex Casinh(const SComplex& z) {
	return MI*Casin(IU*z); // (1/i)arcsin(iz)	
}
#endif
