/*  sdmismlt.cpp  by K.Tsuru  */
// function ID = 310  DRADIX, BRADIX
/******************************************************************
SDouble and SDecimal classes
It examines that "*this" is much less than "a" or not.
When you use as "b.IsMLT(a)" you can read "b is much less than a?".
It returns b << a ? 1 : 0;
******************************************************************/
#ifndef SN_H
#include "sn.h"
#endif
bool SDouble::IsMLT(const SDouble& a) const {
	if(!Sign(310)) return true;	// b = 0 && a != 0

	if(IsPointFixed() && IsHidden()) return true;	// for any value of a

	int de = a.NetRdxExp() - NetRdxExp();
	return ( de > 0 ) && ( (uint)de >= EffFig() );
}
