/*  sdomltdb.cpp  by K.Tsuru  */ 
// function ID = 332	DRADIX
/********************************
SDouble : SDouble*double
*********************************/
#ifndef SN_H
#include "sn.h"
#endif
SDouble operator*(const SDouble& m, double n){
	if( (m.Sign(332) == 0) || (n == 0.0) ) return SDZero(m);
	if(m.Type() == m.BIN_DEC) return DDMult(m , n);	// Must use XsMult()

	long N;
	int e;
	int d2l = doubleTolongExp(n, &N, &e, m.SlOpMaxValue());

	if(d2l){
		ulong p = (ulong)labs(N);
		SDouble r = DsMult(m, p);
		if(e) r.MultPow10(e);	// cannot use BIN_DEC
		if(n < 0) r.ChangeSign();
		return r;
	}
	return DDMult(m , n);
}
