/* sibscvbn.cpp  by K.Tsuru  */
// function ID 3557   BRADIX
/***************************************************************
SN library
SInteger class
DRADIX ---> BRADIX radix conversion
A radix conversion by binary splitting method  ver. 2.17
***************************************************************/

#ifndef SN_H
#include "sn.h"
#endif

static const fType* pf;
static const SInteger R(DRADIX);

class SIPolynomial : public BinarySplittingPoly<SInteger> {
public:
	SIPolynomial(long L) : BinarySplittingPoly<SInteger>(L){
		putTogether();
	}
	void setAB(long k, SInteger& a, SInteger& b) {
		a.SetShort(pf[k]); 	b = R;
	}
};

SInteger BSConvToBin(const SLong& x) {
	pf = x.ReadFigures();
	SIPolynomial sip(x.Head() + 1);

	return sip.getValue();
}
