/* sisccvbn.cpp  by K.Tsuru  */
// function ID 3558   BRADIX
/***************************************************************
SN library
SInteger class
DRADIX ---> BRADIX radix conversion
A radix conversion by square coupling method  since ver. 2.18
***************************************************************/

#ifndef SN_H
#include "sn.h"
#endif

static const SInteger R(DRADIX);

SInteger SCConvToBin(const SLong& x) {
	uint sz = x.Head() + 1u;
	SInteger *w = new SInteger[sz];	// work area
	const fType* pf = x.ReadFigures();

	for(uint i = 0; i < sz; i++) w[i].SetShort(pf[i]);

	SquareCoupling<SInteger> cv(w, R, sz);
	SInteger p;
	p = cv.getValue();	// before delete[];

	delete[] w;

	return p;
}
