/*  smpfact.cpp  by K.Tsuru  */
//
// SLong sample program
// It has been rewritten using "ostream" since version 2.21.
//

const char* title = "<<<<<< Factrial N! calculation >>>>>>";

#include "sn.h"

SLong FactSpeed(uint n)
{
	SLong f;
	Timer timer;
	double t;

	cout << "****** Calculating " << n << "! ******" << endl;
	timer.Start();
	f = Fact(n);
	t = timer.Stop();

	long fig = f.DFigures();
	cout << " " << n << "! CPU time : " << t <<"(sec) ";
	cout <<  "figures = " << fig << " (by Stirling formula = " << Stirling(n) << ")"<< endl;
	cout << "FFTUsedTimes() = " << f.FFTUsedTimes() << "(times)" << endl;
	cerr << "Do you want to output result ?";
	if (fig > 100000) cerr << " It maybe need much time on DOS.";
	cerr << "Yes(1)/No(0)=? ";
	if(GetInt()){
		cout << n << "!= "<< f << endl;
    }
	cout << " " << n << "! CPU time : " << t <<"(sec) ";
	cout << "figures = " << f.DFigures() << "(by Stirling formula = " << Stirling(n) << ")" << endl;
	cout << "FFTUsedTimes() = " <<  f.FFTUsedTimes() << endl;
	Wait();
	return f;
}

int main()
{
	SLong f;
f = factD(20);
cout << f << endl;
cout << factUL(20) << endl;
cout << FactPF(20) << endl;

	int k;
	cout.precision(4);
	ulong n = 0, max_fig = (ulong)f.MaxSize()*(ulong)DFIGURES;	// ver. 2.17.1

	cerr << title << endl;
	cerr << "Maxmum figures in a decimal system = " << max_fig << "." << endl;
	while(1){
		while(1){
			cerr << "Input N(when N<=0 quit) = ? ";
			if((k = GetInt())<=0 ) break;
			n = (ulong)k;
			if(Stirling(n) > max_fig) cerr << "N is too large.";	// ver. 2.17.1
			else break;
		}
		if(k<=0) break;
//		FactSpeed(n);
cout << FactPF(n) << endl;
//cout << LFact(n) << endl;
	}

	Ending();
}
