/*  IdentityTest.cpp  by K.Tsuru  */
/*
Test that identites are satisied or not.
6*arcsin(0.5)-pi = 0
log(e) = 1.0
sin(pi) = 0.0
*/
#include "sn.h"
void Confirm(const char* eq) {
	cout << "*** Confirming an identitiy \"" << eq <<"\" ***" << endl;
}
SDouble IdentityEq0Test(SDouble (*sdfunc)()) {
	SDouble y;
	double t;
	Timer timer;
	timer.Start();
	y = (*sdfunc)();
	t = timer.Stop();
	cout << " CPU time : " << t <<"(sec) ";
	cout <<  "Effective figures = " << y.EffFig()*4 << endl;
	cout << "FFTUsedTimes() = " << y.FFTUsedTimes() << "(times)" << endl;
	cout << y << " <== close to 0? " << endl;
	cout << "================================================" << endl;
	return y;
}
SDouble Cos_a_plus_b() {
	SDouble a = Drand(), b = Drand();
	Confirm("cos(a+b) -cos(a)cos(b)+sin(a)sin(b)=0 ?");
	SDouble c = Cos(a+b), zero;
	zero = c - Cos(a)*Cos(b) + Sin(a)*Sin(b);
	return zero;
}
SDouble Sin_a_plus_b() {
	SDouble a = Drand(), b = Drand();
	Confirm("sin(a+b) -cos(a)sin(b)-sin(a)cos(b)=0 ?");
	SDouble c = Sin(a+b), zero;
	zero = c - Cos(a)*Sin(b) - Sin(a)*Cos(b);
	return zero;
}
SDouble Sqrt2_square_Eq0() {
	Confirm("2 - sqrt(2)^2= 0 ?");
	SDouble s = Sqrt(2.0);
	return 2.0 - s*s;
}
SDouble Asin_0pt5_6_pi_Eq0() {
	Confirm("6*arcsin(0.5)-pi = 0 ?");
	SDouble a, zero;
	a = Asin(0.5);
	zero = 6*a - Pi();
	return zero;
}

SDouble Sin_pi_Eq_0() {
	Confirm("sin(pi) = 0 ?");
	SDouble pi, zero;
	pi = Pi();
	zero=Sin(pi);
	return zero;
}
SDouble Log_e_Eq_1() {
	SDouble e, one, zero;
	Confirm("log(e)-1 =0.");
	e = E();
	one=Log(e);
	zero = 1 - one;
	return zero;
}
SDouble Euler_s_formula() {
	SDouble x = Drand();
	Confirm("z = e^(ix)-cos(x)-i*sin(x) =0.");
	SComplex ix(0.0, x);
	SComplex eix = Cexp(ix), zero, y;
	y = SComplex(Cos(x),Sin(x));
	zero = eix - y;
	cout << "In complex expression z =" << zero << endl;
	return Re(zero)+Im(zero);
}
SDouble Sin_Asin_x_Eq0() {
	SDouble x = Drand();
	Confirm("Sin(Asin(x)) - x=0.");
	SDouble a = Asin(x), zero = Sin(a)-x;
	return zero;
}

int main() {
	SDouble f;
	RealSize C;
	ulong max_fig = (ulong)f.MaxSize()*(ulong)DFIGURES;
	int dgt;
	cerr << "Maxmum figures in a decimal system = " << max_fig << "." << endl;
	while(1){
		cerr << "How many digits do you want (when <= 0 quit) = ? ";
		if((dgt = GetInt())<=0 ) break;
		C.SetEffFig(dgt/4);
		
		IdentityEq0Test(Euler_s_formula);
		IdentityEq0Test(Asin_0pt5_6_pi_Eq0);
		IdentityEq0Test(Sin_pi_Eq_0);
		IdentityEq0Test(Log_e_Eq_1);
		IdentityEq0Test(Sqrt2_square_Eq0);
		IdentityEq0Test(Sin_Asin_x_Eq0);
		
		C.SetEffFig(0);
	}
	Ending();
}
