/*  PiExpSpeedTest.cpp  by K.Tsuru  */
#include "sn.h"
#include "wait.h"
#include "timer.h"
/*
4000000 digits
AGMPi 56.6(sec)
33554429(33millon) digits
RecSqrt(0.5) 23.6799(sec)
Sqrt(2)      16.59(sec) 33554429(figures)
Kondo 6.36(sec)
Sqrt(2) CPU time = 28.5405(sec) 33554461(figures) considerably slower than above.Why?
*/

void ShowTitle(const char* title){
	cout << "****************** " << title << " ********************" << endl;
}

SDouble ConstFuncSpeed(SDouble (*sdfunc)(), const char* fname) {
	Timer timer;
	SDouble r;
	ShowTitle(fname);

	timer.Start();
	r = (*sdfunc)();
	double time = timer.Stop();

	cout << fname << " CPU time = " << time << "(sec) " << r.DFigures() << "(figures)"<< endl;

	return r;
}
void PiFuncCompare() {
	cerr << "Effective figures/4 =? ";
	int fig = GetInt();
	if(fig <= 0) return;

	RealSize C;
	C.SetEffFig(fig);
// pi by Borweins' method improved by by Takahashi and Kanada is fastest.
	SDouble pi = SNPi(), r;
//	ConstFuncSpeed(AGMPi, "AGMPi");
//	ConstFuncSpeed(BorweinsPi, "BorweinsPi");
//	ConstFuncSpeed(ChudnovskysPi, "ChudnovskysPi");
//	r = ConstFuncSpeed(RamanujanPi, "RamanujanPi");
//cout << "diff = " << (pi-r) << endl;
	r = ConstFuncSpeed(RamanujanPi2, "RamanujanPi2");
//cout << pi << endl; // ?
cout << "diff = " << (pi-r) << endl;
//	ConstFuncSpeed(SNPi, "SNPi");
//	ConstFuncSpeed(KlingenstiernaPi, "KlingenstiernaPi");
	
}
void FileOut(SDouble (*pifunc)(), const string& fname) {
	ofstream fout(fname.c_str(),ios::trunc);	 // open file
	Timer timer;
cerr << " Running " << fname << "() function now." << endl;
	timer.Start();
	SDouble pi = (*pifunc)();
	pi.SetFormat(10,0,5);
//cout << pi << endl;
	double time = timer.Stop();
	int p =fname.find_first_of('.');
	fout << "Used function : " << fname.substr(0,p) << "()"<< endl;
	fout << "CPU time = " << time << "(sec) " << pi.DFigures() << "(figures)"<< endl;
	timer.Start();
	fout << pi << endl;
	double optime = timer.Stop();
	fout << "CPU time of output= " << optime << "(sec) " << endl;
	fout.close();
	cout << "CPU time = " << time << "(sec) " << pi.DFigures() << "(figures)"<< endl;
}
SDouble sqrt2(){return Sqrt(2.0);}
int main() {
	RealSize C;
	cerr << "How many digits do you want? = ";
	int fig = GetInt();
	C.SetEffFig(fig/4);
SDouble piCh = ConstFuncSpeed(ChudnovskysPi, "ChudnovskysPi"), dif;
Wait("Do you compare with RamanujanPi() ?");
dif = piCh-RamanujanPi();
cout << dif <<" <-- 0?" << endl;

// 33554432 /4 = 8388600
//FileOut(RamanujanPi2,"RamanujanPi2.dat");
//FileOut(ChudnovskysPi,"ChudnovskysPi-5U.dat");
//FileOut(SNE,"e(mine)33millon.dat");
//FileOut(sqrt2,"sqrt2(mine)33millonL1.dat");
/*	SDouble piC = ChudnovskysPi(), piR = RamanujanPi(),piR2 = RamanujanPi2(), pi = Pi();
	cout << "ChudnovskysPi()-pi" <<endl <<"diff = " << (pi-piC) << endl;
	cout << "RamanujanPi()-pi" <<endl <<"diff = " << (pi-piR) << endl;
	cout << "RamanujanPi2()-pi" <<endl <<"diff = " << (pi-piR2) << endl;
//	pi = RamanujanPi2();
//	cout <<"Rpi2 = "<< pi << endl;
//cout << "diff = " << (pi-piL) << endl;
	Wait();
//	PiFuncCompare();
*/
	Ending();
}
