/*  SNDebug.cpp  by K.Tsuru  */
const char* title = "<<< SN test program for debug. >>>\n";
#include "sn.h"
#include <vector>
void TnTableTest(uint N){ // OK
	SNBlock <SLong> T(N+1);
	Timer timer;
	double cpu_time;

	puts("Calculating tangent coefficients by TanCoeffTable() function.");
	timer.Start();
	TanCoeffTable(T, N);
	cpu_time = timer.Stop();
	for(uint n = 1; n<= N; n++){
		printf("T[%u]= ", n);
		T(n).Puts();
	}
	printf("CPU time = %.3f sec.\n", cpu_time);
	Wait("------------ TanCoeffTable() test ended -----------------");
}

void TanCoeffTest(uint N){ // NG
	SNBlock <SLong> T(N+1);
	SLong m;
	uint n;

	puts("Calcuating tangent coefficients by TanCoeff() function.");
	for(n = 1; n <= N; n++) T[n] = TanCoeff(n); // bug error causes in TanCoeff(n)
	for(n = 1; n <= N; n++){
		printf("T[%u]=", n);
		T(n).Puts();
	}
	Wait("------------ TanCoeffTest() ended -----------------");
}
void LFactTableTest(uint N){
	SNBlock <SLong> F(N+1);
	SLong m;
	uint n;

	puts("make factorial table by LFact(n)");
	for(n = 1; n <= N; n++) F[n-1] = LFact(n);
	for(n = 0; n < N; n++) {
		printf("%d!=",n); F(n).Puts();
	} 
	Wait("------------ LFactTest(N) ended -----------------");
}
void FactPF_TableTest(uint N){
	SNBlock <SLong> F(N+1);
	SLong m;
	uint n;

	puts("make factorial table by FactPF(n)");
	for(n = 1; n <= N; n++) F[n-1] = FactPF(n);
puts("end make table");
	for(n = 0; n < N; n++) {
		printf("%d!=",n); F(n).Puts();
	} 
	Wait("------------ FactPF_TableTest(N) ended -----------------");
}
void FactPFTest(uint N){ // NG
	SLong a;
	uint m;
	for(m= 2; m<=N; m++) {
		a = FactPF(m);
		printf("%u! = ", m); a.Puts();
	}
	Wait("------------ FactPF(N) ended -----------------");
}
void SqrtTest(uint N){
	RealSize C;
	C.SetEffFig(N);
	SDouble a;
	a = Sqrt(2.0); // X
//  a = Sin(2.0);  // X	
	a.Puts();
	Wait();
}

int main(){
	uint N;

	ErrorPuts(title);
	fprintf(stderr,"How many terms do you want? ");
	N = GetInt();
	FactPFTest(N);
	LFactTableTest(N); // OK
	FactPF_TableTest(N); // OK
	TnTableTest(N); // OK no bug

	SqrtTest(N); // hung
//	TanCoeffTest(N); // hung

	Ending();
}
