#include <iostream>
#include <math.h>
#ifndef M_SQRT2
#define M_SQRT2     1.41421356237309504880
#endif
#include "sfft.h"
//const double ROUND_DBL_INT = 0.25 +1.0/(1 << 20); //= 0.2500009536... additional value to round double to integer
using namespace std;
fftType fftModfl(const fftType x, fftType *ip){// modfl() my version
	long long int ipl = x;
	*ip = ipl;
	return x-ipl;
}
// normalization after FFT multiplication
fType fftNormalize(fftType x, const fType radix, fftType *carry) {
	fftType r;
	x += ROUND_DBL_INT;
	r = fftFmod(x, (fftType)radix); // x = 123999456.999687001
//cout << "x = "<< x << " r = "<< r << endl;	// r = 9456.9996870011...
	*carry = (x-r)/radix; // carry = 12399.94569999, r = 9457.24968795478344
//	carry = 12399 f = 9457
	return (fType)(r + ROUND_DBL_INT); 
}
int main() {
	fftType x = 123999456.999687, r, q, rdx = 10000.0;
//	double x = 999999.999687 + 0.25, r, q, rdx = 10000.0;
	r = fmodl(x, rdx); // long double version OK on gcc 7.1.0
//	r = fmodl(x+ROUND_DBL_INT, rdx); // long double version OK on gcc 7.1.0
	q = (x-r)/rdx;
	 
	cout.precision(LDBL_DIG); // 18 digits
	cout << " x = " << x << " rdx = " << rdx << endl; 
	cout << "remainder r= " << r << endl; 
	cout << "quot q= " << q << endl; 
fftType c;
fType f = fftNormalize(x, 10000, &c) ;
cout << "x = " << x << " f= " << f << " carry= " << c << endl;

	fftType ip, dp;
	dp = fftModfl(x, &ip); // gcc : modfl() long double version NG 
	cout << "ipart ip= " << ip << endl; 
	cout << "dpart dp= " << dp << endl; 
}
